﻿;/ Created with PureVision v5.63
;/ Sat, 01 Sep 2018 12:00:29
;/ by Hans-Peter Wickern


XIncludeFile "hpwNewLisp_Constants.pb"
XIncludeFile "hpwNewLisp_Windows.pb"

Procedure CallBack1(*CallBackParam)
;   Debug *CallBackParam
   theString.s = PeekS(*CallBackParam,-1,#PB_UTF8)
   MessageRequester("CallBackDemo1", "foo1 with Param: "+ theString)
EndProcedure 

Procedure CallBack2()
   MessageRequester("CallBackDemo2", "foo2 with no Param")
EndProcedure 

Procedure CallBack3(CallBackParamInt.i)
;   Debug CallBackParamInt
   theString.s = Str(CallBackParamInt)
   MessageRequester("CallBackDemo3", "foo3 with Integer-Param: "+ theString)
EndProcedure 

Procedure CallBack4(CallBackParamFloat.d)
;   Debug CallBackParamInt
   theString.s = StrD(CallBackParamFloat,4)
   MessageRequester("CallBackDemo4", "foo4 with Float-Param: "+ theString)
EndProcedure 

;- Main Loop
If Window_Form1()

  Define quitForm1=0
  
  OpenLibrary(0,"newlisp_utf8.dll")
; Define your function pointer, with auto utf8 conversion (and cleaning)
  Prototype newlispEvalStrProto(input.p-utf8)
  newlispEvalStr.newlispEvalStrProto = GetFunction(0, "newlispEvalStr")
  
  Prototype newlispCallbackStrProto(input.p-utf8, callbackaddress.i , calltype.p-utf8 )
  newlispCallbackStr.newlispCallbackStrProto = GetFunction(0, "newlispCallback")
  
;  MessageRequester("Debug", "CallBackAdress1: "+ @CallBack1())
  newlispCallbackStr("foo1", @CallBack1() ,"stdcall")
;  MessageRequester("Debug", "CallBackAdress2: "+ @CallBack2())
  newlispCallbackStr("foo2", @CallBack2() ,"stdcall")
;  MessageRequester("Debug", "CallBackAdress3: "+ @CallBack3())
  newlispCallbackStr("foo3", @CallBack3() ,"stdcall")
;  MessageRequester("Debug", "CallBackAdress4: "+ @CallBack4())
  newlispCallbackStr("foo4", @CallBack4() ,"stdcall")
  
  Repeat
    EventID  =WaitWindowEvent()
    MenuID   =EventMenu()
    GadgetID =EventGadget()
    WindowID =EventWindow()

    Select EventID
      Case #PB_Event_CloseWindow
        Select WindowID
          Case #Window_Form1
            quitForm1=1
        EndSelect


      Case #PB_Event_Gadget
        Select GadgetID
          Case #Gadget_Form1_ListView2
            Select EventType()
              Case #PB_EventType_LeftDoubleClick
                SetGadgetText(#Gadget_Form1_String3, GetGadgetText(#Gadget_Form1_ListView2)) ; Get the current item from the ListView..
            EndSelect
          Case #Gadget_Form1_String3
          Case #Gadget_Form1_Button4
;                MessageRequester("newLisp event", "before call")
                SetGadgetText(#Gadget_Form1_Editor5, PeekS(newlispEvalStr(GetGadgetText(#Gadget_Form1_String3)),-1,#PB_UTF8))
;                MessageRequester("newLisp event", "after call")
          Case #Gadget_Form1_Editor5
        EndSelect

    EndSelect
  Until quitForm1
  CloseLibrary(0)
  CloseWindow(#Window_Form1)
EndIf
End

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 27
; FirstLine = 5
; Folding = -
; EnableXP
; Executable = hpwNewLisp.exe
; DisableDebugger